'defdbl a - z  'seems to make no difference to speed, remove for space in PB"
dim bitpatt$(3)
screen 12
dim huge dat%(16384)
dim last(256)
readfonts
wintype% = 1
pi = 3.141592653589793238462643383279
comport$ = environ$("DSPCOM")
if comport$ = "" then
	sound 400 , 2
	print "Environment variable DSPCOM not set   eg. DSPCOM=2"
	end
end if

cmd$ = ucase$(command$)
if cmd$ = "QUICK" then quickstart% = -1
def seg = &h40
comaddr% = peeki(2 * val(comport$) - 2)
out comaddr% + 4 , 3         'set DTR and RTS for interface
locate 5 , 15 : color 14
print
color 10 : locate 7 , 30
print "Setting interface...."
locate 30 , 25
print "Interface on COM";comport$;"  Address ";hex$(comaddr%);
locate 9 , 30
print "Adjust input level..."

if not quickstart% then CheckLevel
locate 15 , 10
color 15 : print "Sampling rate  Hz";
color 12 : print tab(30);"1 "; : color 7 : print "  10000 Hz   100 us           ";
color 12 : print tab(30);"2 "; : color 7 : print "   7143 Hz   140 us           ";
color 12 : print tab(30);"3 "; : color 7 : print "   2500 Hz   400 us           ";
color 12 : print tab(30);"4 "; : color 7 : print "   1000 Hz  1000 us           ";

while not instat : wend
a$ = ucase$(inkey$)
select case a$
case "4"
	BaseSampleRate = 1000
case "2"
	BaseSampleRate = 1e6 / 140
case "3"
	BaseSampleRate = 2500
case "1" , chr$(13)
	BaseSampleRate = 10000
case else
	sound 400 , 1
	end
end select
locate 20 , 15
input "Decimation factor        (1)    ",decim%
if decim% = 0 then decim% = 1
samplerate =  BaseSampleRate / decim%
locate 22 , 15
input "Recording interval, s    (1)    ",recordInt
if recordInt = 0 then recordInt = 1
locate 24 , 15
input "Averaging value          (8)    ",avno%
if avno% = 0 then avno% = 8
nsamples% = 1000
if recordint < (nsamples% / samplerate) then
	nsamples% = recordint * samplerate
	recno% = 1
else
	recno% = recordInt * samplerate / nsamples%
end if
locate 26 , 15
input "Filename for data  [rtn] = none ",filename$
if filename$ > "" then open "o" , 2 , filename$
cls
'on error goto errhndlr
color 7 : locate 30 , 1
axes

call ReadAdc (1000)
for fill% = 0 to 999
	fillvalue = fillvalue + dat%(fill%) ^ 2
next fill%
fillvalue = fillvalue / 1000
for fill% = 0 to avno% - 1      'preload averaging array
	last(fill%) = fillvalue
next fill%
co% = 10
do
	call TimeCheck(tim$ , tick% , filetime$)
	if tick% then
		if tim$ > "" then call textxy(tim$ , px% + 13 , 17 , co% , 0 , 1) : _
					ltick% = 5 else ltick% = 10
		line (px% + 20 , 0) - (px% + 20 , ltick%) , co%
	end if
	recsum = 0
	sumsig = 0
	for z% = 1 to avno% - 1
		sumsig = sumsig + last(z%)
		last(z% - 1) = last(z%)
	next z%
	sumsq = 0
	for reccount% = 1 to recno%
		if not quickstart% then	call ReadAdc (nsamples%)
		for counter% = 0 to nsamples% - 1
			sumsq = sumsq + dat%(counter%) ^ 2
		next counter%
		if instat then
			ik$ = ucase$(inkey$)
			if ik$ = chr$(27) then exit for
			if ik$ = chr$(0 , 59) then	call MakeBMP("LVMON")
			if ik$ = "C" then cls : axes
			ik$ = ""
		end if
	next reccount%
	power = sumsq / nsamples% / recno%
	last(avno% - 1) = power

	avpower = (sumsig + power) / avno%
	if avpower > 0 then db = 10 * log10(avpower) else db = -99
	locate 29  , 70
	print using "### dB";db;
	py% = 480 - db * 10
	if px% = 0 or totalcount& < avno% then
		pset (px% + 20, py%) , co%
	else
		line (lastpx% + 20, lastpy%) - (px% + 20 , py%) , co%
	end if
	px% = (px% + 1) mod 620
	if px% = 0 then co% = ((co% + 1) mod 7) + 9
	lastpx% = px%
	lastpy% = py%
	if filename$ > "" then
		print #2 , filetime$ + " " + using$("###.## dB" , db)
	end if
	incr totalcount&
loop until ik$ = chr$(27)
end
'========================================================================
sub ReadAdc (n%)
	shared decim% , comport$, comaddr% , dat%()
	out comaddr% + 4 , 3
	open "com" + comport$ + ": 115200 , n , 8, 1 , dt , ds, cs , cd , me , fe" as 1 len = 30000
	for i% = 0 to n% - 1
		for decimcount% = 1 to decim%
			do until loc(1) > 0
			loop
			a$ = input$(loc(1) , 1)
			value% = asc(a$) - 128
			if decimcount% = 1 then
				dat%(i%) = value%
			else
				dat%(i%) = value% / decim% + dat%(i%)
			end if
		next decimcount%
	next i%
	close 1
	out comaddr% + 4 , 3
end sub
'=================================================================
sub CheckLevel
	shared comport$, comaddr%, dat%()
	close 1   'since probably already open
	for t% = 0 to 4095
		dat%(t%) = 0
	next t%
	out comaddr% + 4 , 3
	open "com" + comport$ + ": 115200 , n , 8, 1, ds, cs , cd , me , fe" as 1 len = 30000
	line (191 , 230) - (191 , 254) , 10
	line (449 , 230) - (449 , 254) , 10
	do
		do until loc(1) > 0
			if instat then ik$ = inkey$
		loop
      if ik$ = chr$(27) then end
		a$ = input$(loc(1) , 1)
		value% =  abs(asc(a$) - 128)
		if value% > 126 then co% = 12 else co% = 11
		line (192 , 240) - (448 , 243) , 0 , bf
		line (320 - value% , 240) - (320 + value% , 243) , co% , bf
		if instat then ik$ = inkey$
	loop until ik$ > ""
	close 1
   out comaddr% + 4 , 3
end sub
'=========================================================================
sub MakeBmp(basename$)       'Palette table assumes EGA compatibility
	filename$ = dir$(basename$ + "???.bmp")
	n% = val(mid$(filename$ , 6, 3))
	do
		f$ = dir$
		n% = max(val(mid$(f$ , 6, 3)) , n%)
	loop until f$ = ""
	n$ = mid$(str$(min(n% + 1, 999)) , 2)
	do while len(n$) < 3
		n$ = "0" + n$
	loop
	f$ = basename$ + n$ + ".BMP"
	locate 29 , 60
	print using "\            \    ";f$;
	bwidth& = 640           'previously set by   PALETTE CO%,CO%
	bheight& = 480
	ColoursInTable& = 16
	BitsPerPixel% = 4        '1 / 4 / 8 / 24  only
	NPlanes% = 1             '1 only
	InfoSize& = 40

	ImageSize& = bwidth& * bheight& * BitsperPixel% / 8
	dataoffset& = 54 + ColoursInTable& * 4
	filesize& = dataoffset& + ImageSize&

	t = timer
	if instr(ucase$(f$) , ".BMP") = 0 then f$ = f$ + ".BMP"
	fi% = freefile
	open "b" , fi% , f$
	i1% = 0 : i2% = 0 : compression& = 0
	bm$ = "BM"
	put$ fi% , bm$
	put fi% , 2 , filesize&
	put fi% ,, i1%
	put fi% ,, i2%
	put fi% ,, DataOffset&
	put fi% ,, InfoSize&
	put fi% ,, bwidth&
	put fi% ,, bheight&
	put fi% ,, NPlanes%
	put fi% ,, BitsPerPixel%
	put fi% ,, compression&
	put fi% ,, ImageSize&
	put fi% ,, XPelsPerMetre&
	put fi% ,, YPelsPerMetre&
	put fi% ,, ColoursInTable&
	put fi% ,, ImportantColours&

	seek fi% , 54
	for rgb% = 0 to 15
		reg 1 , &h1015
		reg 2 , rgb%
		call interrupt &h10
		b% = (reg(3) mod 256) * 4
		g% = (reg(3) \ 256) * 4
		r% = (reg(4) \ 256) * 4
		pa$ = chr$(b%) + chr$(g%) + chr$(r%) + chr$(0)
		put$ fi% , pa$
	next rgb%

	seek fi% , dataoffset&         'data starts at bottom left of picture
	nibble% = 0
	for y% = bheight& - 1 to 0 step -1
		dat$ = ""
		for x% = 0 to bwidth& - 2 step 2
				d% = 16 * point (x% , y%) + point (x% + 1 , y%)
				dat$ = dat$ + chr$(d%)
		next x%
      put$ fi% , dat$
	next y%
	close fi%
	sound 1750 , 2
	locate 29 , 60
	print  space$(17);
end sub

sub TimeCheck(t$ , tick% , ft$)
	static lasth% , lastm% , repeat%
	shared recordInt , co%
	t$ = ""
	tick% = 0
	tim$ = time$
   dat$ = date$
	h% = val(mid$(tim$ , 1 , 2))
	m% = val(mid$(tim$ , 4 , 2))
	if repeat% then
		select case recordint
		case <= 2 				'Ticks and labels every minute
			if m% <> lastm% then tick% = -1 : t$ = mid$(tim$ , 4 , 2)
		case <= 20				'Tickes every 1 minute, labels every 10mins
			if m% <> lastm% then tick% = -1
			if tick% and (m% mod 10 = 0) then t$ = mid$(tim$ , 4 , 2)
		case <=100				'Ticks every 10mins,  labels every hour
			if m% <> lastm% and m% mod 10 = 0 then tick% = -1
			if tick% and (h% <> lasth%) then t$ = left$(tim$ , 2)
		case else				'Ticks every hour, labels at 6 Hours
			if h% <> lasth% then tick% = -1
			if (h% mod 6 = 0) and tick% then t$ = left$(tim$ , 2)
		end select
	else
		repeat% = -1
	end if
	lasth% = h%
	lastm% = m%
	color 7
	locate 30 , 70 : print tim$;

	ft$ = mid$(dat$ , 4 , 2) + mid$(dat$ , 1 , 2) + mid$(dat$ , 7) + " " +_
		mid$(tim$ , 1 , 2) + mid$(tim$ , 4 , 2) + mid$(tim$ , 7 , 2)
end sub

sub textxy(text$ , x% , y% , colour% , background% , fontno%)
	shared bitpatt$()
	maxtext% = 620
	select case fontno%
	case 1 , 5 , 7                '7x5 font
		rowsperchar% = 8
		colsperchar% = 6
		arrayref% = 0
	case 2 , 8
		rowsperchar% = 8
		colsperchar% = 8
		arrayref% = 1
	case 3 , 14
		rowsperchar% = 14
		colsperchar% = 8
		arrayref% = 2
	case 4 , 16
		rowsperchar% = 16
		colsperchar% = 9
		arrayref% = 3
	end select

	for charcount% = 1 to len(text$)
		ch% = asc(mid$(text$ , charcount% , 1))
		xbase% = x% + colsperchar% * (charcount% - 1)
		if xbase% > maxtext% then exit for
		for rw% = 0 to rowsperchar% - 1
			thisch% = asc(mid$(bitpatt$(arrayref%) , 1 + rw% + ch% * rowsperchar% , 1))
			for bitno% = 0 to colsperchar% - 1
				if bit(thisch% , colsperchar% - bitno% - 1) then
					pset (xbase% + bitno%  , y% + rw% - rowsperchar% ) , colour%
				else
					if background% >= 0 then pset (xbase% + bitno%  , y% + rw% - rowsperchar% ) , background%
				end if
			next bitno%
		next rw%
	next charcount%
end sub

sub ReadFonts
'dim bitpatt$(3)
	shared bitpatt$()
	fino% = freefile
	open "b" , fino% , "allfonts"
	get$  fino% , 2048 , bitpatt$(0)
	get$  fino% , 2048 , bitpatt$(1)
	get$  fino% , 3584 , bitpatt$(2)
	get$  fino% , 4096 , bitpatt$(3)
	close fino%
end sub

sub axes
	shared samplerate, recordInt, avno% , px%
	line (0 , 60) - (0 , 460) , 7
	for db% = 0 to 40 step 2
		plpos% = 460 - 10 * db%
		if db% mod 10 = 0 then
			tick% = 10
			call textxy(using$("##" , db%) , 11 , plpos% + 5 , 15 , 0 , 1)
		else
			tick% = 4
		end if
		line (0 , plpos%) - (tick% , plpos%) , 15
	next db%
	call textxy("dB" , 27 , 65 , 15 , 0 , 1)
	locate 30 , 1
	px% = 0
   print using "Fs #####Hz   Recording every ####.#s    Average over #### samples";_
		samplerate, recordInt, avno%;
   dat$ = mid$(date$ , 7) + mid$(date$ , 1 , 2) + mid$(date$ , 4 , 2)
	tim$ = left$(time$ , 5)
	call textxy(dat$ , 0 , 35 , 7 , 0 , 2)
	call textxy(tim$ , 0 , 45 , 7 , 0 , 2)
end sub

errhndlr:
	resume next

