pi = 3.141592654
cls
dim dat%(1000 , 1) , lastpl%(640 , 1)
comport$ = environ$("DSPCOM")
if comport$ = "" then
	sound 400 , 2
	print "Environment variable DSPCOM not set   eg. DSPCOM=2"
	end
end if
def seg = &h40
comaddr% = peeki(2 * val(comport$) - 2)
out comaddr% + 4 , 3       'set DTR and RTS for interface
out comaddr% + 3 , &h80    'set DLAB
out comaddr% + 0 , 1
out comaddr% + 1 , 0            'Divisor = 1 for 115200 baud
out comaddr% + 3 , 3            'Set For 8 bit, 1 stop , no parity
input "Frequency offset , Hz   ",freq

phaseincr = -freq / 1000

screen 12
axes
dispfact% = 4

call resync
do
	ik$ = ""
	for a% = 1 to 4
		do
			lcr% = inp(comaddr% + 5)
			drdy% = bit(lcr% , 0)
		loop until drdy%
		value? = inp(comaddr%)

		errflag% = 0
		select case a%
		case 1
			ihi% = value?
		case 2
			ilo% = value?
		case 3
			qhi% = value?
		case 4
			qlo% = value?
		end select
	next a%

	if ihi% > 3 then errflag% = -1
	if qhi% < &hFC then errflag% = -1

	i% = (ihi% and &h3) * 256 + ilo%
	q% = (qhi% and &h3) * 256 + qlo%
	if i% > 512 then decr i% , 1024
	if q% > 512 then decr q% , 1024

	phaseincr = -freq / 1000
	phase = frac(phase + phaseincr)
	cphase = cos(2 * pi * phase)
	sphase = sin(2 * pi * phase)
	temp% = i% * cphase - q% * sphase
	q% = q% * cphase + i% * sphase
	i% = temp%

	if errflag% then
		incr errcount%
		locate 30 , 1
		print errcount%;
		call resync
	else
		pset (320 + i% \ 2 , 340 - q% \ 2) , 15   '- coz plot is -ve up
		pli% = 50 - i% \ 16
		plq% = 100 - q% \ 16
		plx% = x% \ dispfact%
		pset (plx% , lastpl%(plx% , 0)) , 0
		pset (plx% , lastpl%(plx% , 1)) , 0
		lastpl%(plx% , 0) = pli%
		lastpl%(plx% , 1) = plq%
		pset (plx% , pli%) , 10
		pset (plx% , plq%) , 12
	end if

	incr x%
	if x% = 640 * dispfact% then
		x% = 0
	end if

	if instat then
		ik$ = ucase$(inkey$)
		select case ik$
		case chr$(0 , 73)
			freq = freq + 1
		case chr$(0 , 81)
			freq = freq - 1
		case chr$(0 , 72)
			freq = freq + .1
		case chr$(0 , 80)
			freq = freq - .1
		case chr$(0 , 77)
			freq = freq + .01
		case chr$(0 , 75)
			freq = freq - .01

		case chr$(27)
			end
		case "C"
			axes
			x% = 0
			iterate loop
		case "D"
			dispfact% = min(dispfact% * 2 , 50)
			x% = 0
			axes
		case chr$(4)
			dispfact% = max(dispfact% / 2 , 1)
			x% = 0
			axes
		end select
		ik$ = ""
	  locate 30 , 70
		print using "+###.##";freq;
	end if
	done% = -1
loop until ik$ = chr$(27)
end

sub resync              'read serial port until bytes fall into sync again
	shared comaddr%
	do
		a0? = a1?
		a1? = a2?
		a2? = a3?
		do
			lcr% = inp(comaddr% + 5)
			drdy% = bit(lcr% , 0)
		loop until drdy%
		a3? = inp(comaddr%)
		b% = (b% + 1) mod 4
	loop until a0? <= 3 and a2? >= &hFC   'just read QHI
end sub

sub axes
	shared errcount% , freq
	cls
	circle (320 , 340) , 128 , 8
	line (0 , 50) - (639 , 50) , 8
	line (0 , 100) - (639 , 100) , 8
	locate 30 , 70
	print using "+###.##";freq;
	locate 30 , 1
	print errcount%;
end sub
