data 0,11111,1,01111,2,00111,3,00011,4,00001,5,00000
data 6,100000,7,11000,8,11100,9,11110,/,10010,.,001100,?,001100
data A,01,B,1000,C,1010,D,100,E,0,F,0010,G,110,H,0000,I,00,J,0111,K,101
data L,0100,M,11,N,10,O,111,P,0110,Q,1101,R,010,S,000,T,1,U,001,V,0001
data W,011,X,1001,Y,1011,Z,1100,"END" , "END"
dim cw$(64, 1)
cls
print tab(20);"VERY SLOW CW FOR LF COMMUNICATIONS"
port$ = environ$("DSPLPT")
if port$ = "" then
	print "Environment variable  DSPLPT  not set"
	sound 400 , 1
	end
end if
keyerbit% = 0
txbit% = 1
portdata% = &h80    'MSB = +V Ref for UTC input pulse data
fastints% = 2

def seg = &h40
portaddress% = peeki(2 * val(port$) + 6)
out portaddress% , portdata%
locate 25 , 50 : print "LPT";port$;"   Address $";hex$(portaddress%);"   Bit";keyerbit%;
do
	read cw$(charcount% , 0) , cw$(charcount% , 1)
	incr charcount%
loop until cw$(charcount% -1 , 0) = "END"
decr charcount%
locate 3 , 10
input "Text   ",text$
text$ = ucase$(text$)
if text$ = "" then end
msg$ = ""
for a% = 1 to len(text$)
	thischar$ = mid$(text$ , a% , 1)
	bitpatt$ = ""
	if thischar$ = " " then
		msg$ = msg$ + "00"
	else
		for x% = 0 to charcount%
			if thischar$ = cw$(x% , 0) then bitpatt$ = cw$(x% , 1) : exit for
		next x%
		for y% = 1 to len(bitpatt$)
			if mid$(bitpatt$ , y% , 1) = "0" then
				thesebits$ = "1"
				incr nones% , 1
			else
         	thesebits$ = "111"
				incr nones% , 3
			end if
         msg$ = msg$ + thesebits$ + "0"
		next y%
      msg$ = msg$ + "00"
	end if
next a%
msg$ = msg$ + "00"

length% = len(msg$)
color 15 : locate 3 , 17
print text$;
color 7
print using " Length ###" ; length%
locate 4 , 10
input; "Dot interval  (s)   ",interval
if interval = 0 then interval = 10
locate 4 , 10
print using "Dot interval ####.#s       ";interval
nticks% = interval * 65536 / 3600
interval = nticks% * 3600 / 65536 		'get exact value

Fastints% = min(nticks% / length% / 8 , 2)

FastDelay = fastints% * 3600 / 65536
timefast = FastDelay * (length% + 3)
if fastints% = 0 then fast$ = "No Fast message"else_
	fast$ = using$("Fast msg at ##WPM" , 21 / fastints%) + _
	using$(" Duration ##.#s" , timefast) + _
	using$("  ##% of dot period" , timefast / interval * 100)
rptime = length% * interval
rpts$ = using$("##" , rptime mod 60)
if left$(rpts$ , 1) = " " then mid$(rpts$ , 1 , 1) = "0"
rptm$ = using$("##:" , rptime \ 60 mod 60)
if left$(rptm$ , 1) = " " then mid$(rptm$ , 1 , 1) = "0"
rpt$ = using$("###:" , rptime \ 3600) + rptm$ + rpts$

locate 4 , 40
print using "Message duration \       \  ";rpt$
locate 5 , 10
print fast$
locate 7 , 10
color 12 : print "C"; : color 7 : print "ontinuous repeat   or   [";
color 12 : print "S"; : color 7 : print "]ingle transmission only"
while not instat : wend
ik$ = ucase$(inkey$)
if ik$ = chr$(27) then end
if ik$ = "C" then single% = 0 else single% = -1
locate 7 , 10
if single% then print "Single transmission only"; else_
					 print "Repeated transmission";
print space$(40)
locate 9 , 10
input; "Start time HHMMSS  [rtn] for immediate  ",stime$
if stime$ > "" then
	do                    'strip out spurious chars in time string
		ii% = instr(stime$ , any " ,:-.")
		if ii% > 0 then stime$ = left$(stime$ , ii% - 1) + mid$(stime$ , ii% + 1)
	loop until ii% = 0
	if len(stime$) < 5 then stime$ = stime$ + "00"   'add seconds if not there
	do until len(stime$) = 6              'pad with zeros
		stime$ = "0" + stime$
	loop
		'add in colons to match PC time format
	stime$ = left$(stime$ , 2) + ":" + mid$(stime$ , 3 , 2) + ":" + right$(stime$ , 2)

	locate 9 , 21
	print stime$ + space$(40);
	do
		tim$ = time$
		locate 9 , 70
		print tim$
	loop until tim$ = stime$ or inkey$ = chr$(27)
end if
locate 9 , 10
print space$(70)
bit set portdata% , txbit%
out portaddress% , portdata%
tim = timer
do
	cury% = 10 : curx% = 1
	incr messages%
	for a% = 1 to length%
		thischar% = val(mid$(msg$ ,a% ,1 ))
		locate cury% , curx%
		color 15
		if thischar% then color 15 : print "="; else color 8 : print ".";
		cury% = csrlin : curx% = pos
		color 7
		timetaken = timer - tim
		if timetaken < -1 then tim = tim - 86400 : timetaken = timer - tim    'over midnight
		locate 25 , 1 : print using "Tx time #######s Message No ##### ";timetaken,messages%;
		if instat then ik$ = inkey$
		if ik$ = chr$(27) then exit loop
		call sendchar(thischar%)
	next a%
	for cl% = 10 to cury%
		locate cl% , 1 : print space$(80)
	next cl%
	sound 2000 , 2
loop while not single%
bit reset portdata% , keyerbit%
bit reset portdata% , txbit%
out portaddress% , portdata%
locate 25 , 35 : print "FINISHED"
end

sub SendChar(x%)
	shared portaddress% , interval ,  keyerbit% , timefast , portdata%
	if x% then
		bit set portdata% , keyerbit%
		locate 8 , 36
		print "Signal ON ";
	else
		bit reset portdata% , keyerbit%
		locate 8 , 36
		print "Signal OFF";
	end if
	out portaddress% , portdata%
	delay(interval - timefast)
	if timefast > 1 then
		if x% then call SendFast else delay timefast
	end if
end sub

sub SendFast
	shared length% , msg$ , portdata% , portaddress% , keyerbit% , fastdelay
	locate 8 , 36 : print "Fast ID   ";
	bit reset portdata% , keyerbit%
   out portaddress% , portdata%
	delay FastDelay * 3					'initial gap
	for a% = 1 to length%
		thischar% = val(mid$(msg$ ,a% ,1 ))
		if thischar% then
			bit set portdata% , keyerbit%
		else
			bit reset portdata% , keyerbit%
		end if
      out portaddress% , portdata%
		delay FastDelay
	next a%
end sub
